/******************************************************************************
				shell.exe copyright (c) 2000-2003 t_kumagai

	shell.txc VF command.com gꍇ̕s肳ɑς؂ꂸɍ쐬B
	make g΂ƂlōĂ̂ŁA@\łB
	gݍ݃R}hƂāAdir, cd g܂BIvV܂B

	@\ȃVFKvȏꍇ͕ʂ̃VFgĂB

v0.02	2003/03/25
	E擪󔒖ǉ
v0.01	2003/03/24
	E[CTRL]+[C],;,& ǉ
v0.00	2000/12/30
	Eshell.txc 肵 make gVF~ƂƂŐVK쐬B
	  tcsh, zsh, sh  makeĂяoR}hsłBcommand.com 
	  IꍇA̓삪ςȂقǕsɂȂB
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <exception>
#include <stdexception>

using namespace std;

class interrupt_exception : public exception {};
class terminal_exception : public exception {};

const char* ver_info = "shell.exe ver0.02 copyright (c) 2000-2003 t_kumagai";
const char* INTERRUPT_EVENT_NAME = "global-shell-interrupt";
static bool interrupted = false;
static HANDLE hInterrupt = NULL;

BOOL __stdcall handler_routine(DWORD dwCtrlType)
{
	if (dwCtrlType != CTRL_C_EVENT)
		return FALSE;

	interrupted = true;
	return TRUE;
}

BOOL isinterrupted()
{
	if (WaitForSingleObject(hInterrupt, 1) == WAIT_OBJECT_0)
		GenerateConsoleCtrlEvent(CTRL_C_EVENT, 0);
	return interrupted;
}

void throw_ifinterrupted()
{
	if (interrupted)
		throw new interrupt_exception();
}

void clear_interrupted()
{
	ResetEvent(hInterrupt);
	interrupted = false;
}

void show_prompt()
{
	char s[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, s);
	printf("%s>" , s);
	fflush(stdout);
}

// src ̃|Cg̕񂩂󔒂܂ '"' ŋ؂ꂽ
// dst ȉɊi[ src, dst XVB
// .str      .      ->  str.    arg.
// |         |             |       |
// (src)     (dst)  ->   (src)  (dst)
//
// str:	\s*\S+\s*|\s*"[^\"]+"\s
// arg: \S*|[^\"]*
int parse_command(char** dst, char** src)
{
	int ret;
	char* s = *src;
	char* d = *dst;
	// 󔒓ǂݔ΂
	while (*s == ' ')
		*s++;
	while (*s == '"') {
		s++;
		do {
			*d++ = *s++;
		} while (*s && *s != '"');
	}
	while (*s && *s != ' ')
		*d++ = *s++;

	ret = (d - *dst);
	*d++ = '\0';
	*src = s;
	*dst = d;
	
	return ret;
}

DWORD call_command(char* cmdline, bool background)
{
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	GetStartupInfo(&si);
	DWORD ret = 0;

	if (!CreateProcess(NULL, cmdline, NULL, NULL, TRUE,
		CREATE_DEFAULT_ERROR_MODE, NULL, NULL, &si, &pi)) {
		printf("%s: Command not found.\n", cmdline);
		fflush(stdout);
	}
	if (!background) {
		while (WaitForSingleObject(pi.hProcess, 10) == WAIT_TIMEOUT)
			isinterrupted();
		GetExitCodeProcess(pi.hProcess, &ret);
	}
	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);
	throw_ifinterrupted();

	return ret;
}

void print_attr(char c, DWORD attr)
{
	if (attr) {
		putchar(c);
	} else {
		putchar('-');
	}
}

int is_execute(char* fname)
{
	char s[MAX_PATH];
	char* p = s;
	char* f = fname;
	while ((*p++ = toupper(*f++)) != '\0')
		;
	// gqȊOł}b`Ă܂B
	if (strstr(s, ".EXE") || strstr(s, ".BAT") || strstr(s, ".COM"))
		return 1;
	
	return 0;
}

void on_ver()
{
	puts(ver_info);
	fflush(stdout);
}

void on_dir(char* mask)
{
	HANDLE hFind;
	WIN32_FIND_DATA fd;
	FILETIME ft;
	SYSTEMTIME st;
	
	if ((hFind = FindFirstFile(mask, &fd)) == INVALID_HANDLE_VALUE) {
		printf("%s : not found\n", mask);
		return;
	}
	do {
		throw_ifinterrupted();
		FileTimeToLocalFileTime(&fd.ftLastWriteTime, &ft);
		FileTimeToSystemTime(&ft, &st);
		print_attr('d', fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY);
		print_attr('r', fd.dwFileAttributes & FILE_ATTRIBUTE_READONLY);
		print_attr('s', fd.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM);
		print_attr('h', fd.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN);
		print_attr('a', fd.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE);
		print_attr('x', is_execute(fd.cFileName));

  		printf(" %10d", fd.nFileSizeLow);
		printf(" %02d/%02d/%02d %02d:%02d:%02d",
			st.wYear % 100, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
  		printf(" %s\n", fd.cFileName);
  		fflush(stdout);
	} while (FindNextFile(hFind, &fd));
	FindClose(hFind);
}

void on_cd(char* dir)
{
	if (SetCurrentDirectory(dir) == 0) {
		printf("%s : No Such file or directory.\n", dir);
		fflush(stdout);
	}
}

void get_command(char* cmdlines)
{
	*cmdlines = '\0';
	show_prompt();
	gets(cmdlines);
}

void do_command(char* cmdline)
{
	const MAX_ARG = 64;
	char* av[MAX_ARG];
	char avs[MAX_PATH];
	int ac = 0;
	char* last = cmdline;
	char* p = avs;
	char* prev = avs;
	int i;
	bool background = false;
	while (*cmdline == ' ')
		cmdline++;

	while (parse_command(&p, &last)) {
		av[ac++] = prev;
		prev = p;
	}
	// command& 
	if (--last >= cmdline) {
		if (*last == '&') {
			*last = '\0';
			background = true;
		}
	}

	if (ac <= 0)
		return;

	if (strcmp(av[0], "exit") == 0) {
		throw new terminal_exception();
	} else if (strcmp(av[0], "ver") == 0) {
		on_ver();
	} else if (strcmp(av[0], "dir") == 0) {
		if (ac > 1)
			for (i=1; i<ac; i++) {
				on_dir(av[i]);
			}
		else
			on_dir("*.*");
	} else if (strcmp(av[0], "cd") == 0) {
		if (ac > 1) {
			on_cd(av[1]);
		}
	} else call_command(cmdline, background);
}

int main(int argc, char** argv)
{
	char cmdlines[MAX_PATH];
	char* cmdline;
	
	puts(ver_info);
	puts("gݍ݃R}hƂĈȉ̃R}hg܂");
	puts("    cd [fBNg]");
	puts("    dir [t@C(ftHg*.*)]");
	puts("    (IvV͂܂)");
	fflush(stdout);
	hInterrupt = OpenEvent(EVENT_ALL_ACCESS, TRUE, INTERRUPT_EVENT_NAME);
	SetConsoleCtrlHandler(handler_routine, TRUE);
	try {
		for (;;) {
			try {
				get_command(cmdlines);
				clear_interrupted();
				cmdline = strtok(cmdlines, ";");
				while (cmdline) {
					do_command(cmdline);
					cmdline = strtok(NULL, ";");
				}
			} catch (interrupt_exception* e) {
				puts("^C");
				fflush(stdout);
			}
		}
	}
	catch(...) {
	}

	return 0;
}
